/***************************************************************************************************/
/* example.pov  - Copyright Chris Bartlett 2004                                                    */
/* This work is licensed for royalty free re-use under the terms of the POV-Person License.        */
/* To view a copy of this license, visit http://www.telinco.co.uk/c_bartlett/license/license.htm   */
/***************************************************************************************************/

global_settings { max_trace_level 10 }
#version 3.5;
#ifndef(ppCamera)  #declare ppCamera="Crowd4";  #end // Crowd1 = Front Right, Crowd2 = Front, Crowd3 = In amongst.

#include "povperson.inc"

//#declare ppCrowdFigureList = array[1];
//#declare ppCrowdFigureList[0] = ppFigure("ppann.inc","random","pplookstraight.inc","random","ppoutfit2.inc");

#local I = 0;
#declare ppCrowdFigureList = array[40];
#while (I<dimension_size(ppCrowdFigureList,1))
  #declare ppCrowdFigureList[I] = ppFigure("pprandomcharacter.inc","pprandomstyle.inc","pprandomexpression.inc","pprandompose.inc","pprandomoutfit.inc");
//  #declare ppCrowdFigureList[I] = ppFigure("ppbill.inc","ppstyle7.inc","smile","pprandompose.inc","none");
//  #declare ppCrowdFigureList[I] = ppFigure("ppalf.inc","ppstyle7.inc","smile","ppsitting.inc","ppoutfit2.inc");
  #local I = I + 1;
#end

#declare mySteps = union {
  #local I = 1;
  #while (I<8)
    box {<-2,-0.2+I*0.2,-8+0.6*I><2,0+I*0.2,-3.5>}
    #local I = I + 1;
  #end
}

#declare myPlatform = union {
  box {<-25,-1,-8><8,0,25> rotate y*45}
  cylinder {<0,-1,0><0,1.4,0>,4}
  object {mySteps}
  rotate x
  pigment {color rgb <1,1,1>}
}

#declare ppFigurePositions = array[1000];
#declare ppCrowdPlatform   = object {myPlatform};
#local   actualPositions1  = ppCrowdPositions(996);

#declare ppCrowdPlatform   = object {mySteps};
#local   actualPositions2  = ppCrowdPositions(4);
#declare myCrowd = ppCrowd(0,ppFigureCounter);



#if (strcmp(substr(ppCamera,1,5),"Crowd")=0) 
  object {myCrowd pigment {rgb <1,1,0>}}
  object {myPlatform}
  plane  {y,0.1 pigment {color rgbt <0,0.5,1,0.5>} normal {bumps 1}}

  light_source { <20, 60,-100> color rgb<1, 1, 1> }   

  #switch (0)
    #case (strcmp(ppCamera,"Crowd1"))
      light_source { <10, 5,-10> color rgb<1, 0.9, 0.9>}   
      camera {location<3,4,-16> look_at<-1,1,5>}
    #break 
    #case (strcmp(ppCamera,"Crowd2"))
      light_source { <0, 14,-16> color rgb<1, 1, 1> }   
      camera {location<0,3.5,-15> look_at<0,1.5,0>}
    #break
    #case (strcmp(ppCamera,"Crowd4"))
      light_source { <0, 14,-16> color rgb<1, 1, 1>*0.5 }   
      camera {location<0,3.5,-15> look_at<0,1.5,0>}
    #break
    #else
      light_source { <-10, 5,-10> color rgb<1, 0.9, 0.9>}   
      camera {location<-3,1.9,-8> look_at<0,1.8,0>}
   #end // End of switch
#end
 
