/***************************************************************************************************/
/* pphuman001accessories.inc  - Copyright Chris Bartlett May 2005.                                 */
/* This work is licensed for royalty free re-use under the terms of the POV-Person License.        */
/* To view a copy of this license, visit http://www.telinco.co.uk/c_bartlett/license/license.htm   */
/***************************************************************************************************/
#ifndef (ppCamera)     #declare ppCamera="Shirt";    #end
#ifndef (POVPerson)    #include "povperson.inc"      #end
#ifndef (ppShowPoints) #declare ppShowPoints = 0;    #end
#ifndef (ppVerbose)    #declare ppVerbose    = 0;    #end
         

// When rendering this include file on its own (e.g. when developing macros) we need a person model to draw clothes around
#if (strcmp(ppCamera,"Boots")=0|strcmp(ppCamera,"Shorts")=0|strcmp(ppCamera,"Trousers")=0|strcmp(ppCamera,"Shirt")=0)
  #declare Ann = object {ppFigure("ppann.inc","ppstyle4.inc","smile","ppstanding.inc","none") rotate y*00} // rotate 35*y translate <0.5,0,1>}
#end

// The ppHeadwear macro for pphuman001accessories takes a head and assigns copies of it to a set of locally declared variables. 
// It is not anticipated that the general user will need to modify this macro.
//
// Parameters:
// -----------
//               - No parameters are passed to this macro. 

#macro ppHeadwear() 
  #local ppSkullObject = object {ppHead scale 1.1 rotate ppBodyPartListOrientation[ppHeadRef] translate ppBodyPartListPosition[ppHeadRef]};
  #local ppSkullStartPos = ppBodyPartListPosition[ppHeadRef];
  #local ppSkullStartVector = vrotate(<0,1,-1.25>,ppBodyPartListOrientation[ppHeadRef]);
  #local ppStartRefVector = vrotate(<0,1.25,1>,ppBodyPartListOrientation[ppHeadRef]);

  ppBobbleHatGenerator();
  #declare ppHatRef = ppAddBodyPart("ppHatRef",object{ppHat});  
#end  

// The ppFootwear macro for pphuman001accessories takes a series of body parts that have previously been added to the POV-Person figure
// definition and assigns copies of them to a set of locally declared variables. 
// It is not anticipated that the general user will need to modify this macro.
//
// Parameters:
// -----------
//               - No parameters are passed to this macro. 

#macro ppFootwear()  
  #declare ppToeCurlAngle = -16;
  #include "pptoepositionwithheels.inc"         // Tuck the toes in
  #ifndef (ppLeftFootwear ) #declare ppLeftFootwear  = 1; #end
  #ifndef (ppRightFootwear) #declare ppRightFootwear = 1; #end
  
  #if (ppLeftFootwear=1)  
  
    #local ppLegObject = ppGetBodyPart(ppLeftCalfRef);    // Get a copy of the lower left leg
    
    #local ppI = ppLeftFootRef;                           // Get a copy of all of the parts of the left foot
    #local ppFootObject = merge {
      #while (ppI<=ppLeftLittleToeTipRef)
        ppGetBodyPart(ppI)
        #local ppI = ppI + 1;
      #end 
    }
    // ------------------------------------ //
    // Definitions to control the Left Boot // 
    // ------------------------------------ //
    // The toe of the boot needs to wrap around the toes
    #local ppToeCentreLines = array[3][5];
    #local ppToeCentreLines[0][0] = ppBodyPartListPosition[ppLeftBigToeTipRef];
    #local ppToeCentreLines[0][1] = ppBodyPartListPosition[ppLeftFirstToeMiddleRef];
    #local ppToeCentreLines[0][2] = ppBodyPartListPosition[ppLeftMiddleToeMiddleRef];
    #local ppToeCentreLines[0][3] = ppBodyPartListPosition[ppLeftThirdToeMiddleRef];
    #local ppToeCentreLines[0][4] = ppBodyPartListPosition[ppLeftLittleToeMiddleRef];
    
    #local ppToeSegmentLength = vlength(ppBodyPartListPosition[ppLeftMiddleToeMiddleRef]-ppBodyPartListPosition[ppLeftMiddleToeTipRef]);
    #local ppTempDisplacement = vrotate(z*ppToeSegmentLength,ppBodyPartListOrientation[ppLeftBigToeTipRef]);
    #local ppToeCentreLines[1][0] = ppBodyPartListPosition[ppLeftBigToeTipRef]+ppTempDisplacement; 
    #local ppToeCentreLines[1][1] = ppBodyPartListPosition[ppLeftFirstToeTipRef];
    #local ppToeCentreLines[1][2] = ppBodyPartListPosition[ppLeftMiddleToeTipRef];
    #local ppToeCentreLines[1][3] = ppBodyPartListPosition[ppLeftThirdToeTipRef];
    #local ppToeCentreLines[1][4] = ppBodyPartListPosition[ppLeftLittleToeTipRef];
    
    //#local ppToeSegmentLength = ppToeSegmentLength;
    #local ppTempDisplacement = vrotate(z*ppToeSegmentLength,ppBodyPartListOrientation[ppLeftBigToeTipRef]);
    #local ppToeCentreLines[2][0] = ppToeCentreLines[1][0]+ppTempDisplacement; 
    #local ppTempDisplacement = vrotate(z*ppToeSegmentLength,ppBodyPartListOrientation[ppLeftFirstToeTipRef]);
    #local ppToeCentreLines[2][1] = ppToeCentreLines[1][1]+ppTempDisplacement; 
    #local ppTempDisplacement = vrotate(z*ppToeSegmentLength,ppBodyPartListOrientation[ppLeftMiddleToeTipRef]);
    #local ppToeCentreLines[2][2] = ppToeCentreLines[1][2]+ppTempDisplacement; 
    #local ppTempDisplacement = vrotate(z*ppToeSegmentLength,ppBodyPartListOrientation[ppLeftThirdToeTipRef]);
    #local ppToeCentreLines[2][3] = ppToeCentreLines[1][3]+ppTempDisplacement; 
    #local ppTempDisplacement = vrotate(z*ppToeSegmentLength,ppBodyPartListOrientation[ppLeftLittleToeTipRef]);
    #local ppToeCentreLines[2][4] = ppToeCentreLines[1][4]+ppTempDisplacement; 
        
    #local ppFootStartPos         = ppBodyPartListPosition[ppLeftMiddleToeBaseRef];
    #local ppMiddleToeOrientation = ppBodyPartListOrientation[ppLeftMiddleToeBaseRef];
    #local ppCalfStartPos         = ppBodyPartListPosition[ppLeftCalfRef];
    #local ppCalfEndPos           = ppBodyPartListPosition[ppLeftThighRef];
    #local ppFootOrientation      = ppBodyPartListOrientation[ppLeftFootRef];
    #local ppHandedness           = "Left";
    
//    #include ppIncludeFile 
    ppBootGenerator();
    #declare ppLeftBoot = object {ppBoot1}
    #declare ppLeftBootRef = ppAddBodyPart("ppLeftBootRef",object{ppLeftBoot});   
  #end

  #if (ppRightFootwear=1)

    #local ppLegObject = ppGetBodyPart(ppRightCalfRef);
    
    #local ppI = ppRightFootRef;
    #local ppFootObject = merge {
      #while (ppI<=ppRightLittleToeTipRef)
        ppGetBodyPart(ppI)
        #local ppI = ppI + 1;
      #end 
    }
    
    // ------------------------------------- //
    // Definitions to control the Right Boot //
    // ------------------------------------- // 
    
    // The toe of the boot needs to wrap around the toes
    #local ppToeCentreLines = array[3][5];
    #local ppToeCentreLines[0][0] = ppBodyPartListPosition[ppRightBigToeBaseRef];
    #local ppToeCentreLines[0][1] = ppBodyPartListPosition[ppRightFirstToeMiddleRef];
    #local ppToeCentreLines[0][2] = ppBodyPartListPosition[ppRightMiddleToeMiddleRef];
    #local ppToeCentreLines[0][3] = ppBodyPartListPosition[ppRightThirdToeMiddleRef];
    #local ppToeCentreLines[0][4] = ppBodyPartListPosition[ppRightLittleToeMiddleRef];
    
    #local ppToeSegmentLength = vlength(ppBodyPartListPosition[ppRightMiddleToeMiddleRef]-ppBodyPartListPosition[ppRightMiddleToeTipRef]);
    #local ppTempDisplacement = vrotate(z*ppToeSegmentLength,ppBodyPartListOrientation[ppRightBigToeTipRef]);
    #local ppToeCentreLines[1][0] = ppBodyPartListPosition[ppRightBigToeTipRef]+ppTempDisplacement; 
    #local ppToeCentreLines[1][1] = ppBodyPartListPosition[ppRightFirstToeTipRef];
    #local ppToeCentreLines[1][2] = ppBodyPartListPosition[ppRightMiddleToeTipRef];
    #local ppToeCentreLines[1][3] = ppBodyPartListPosition[ppRightThirdToeTipRef];
    #local ppToeCentreLines[1][4] = ppBodyPartListPosition[ppRightLittleToeTipRef];
    
    //#local ppToeSegmentLength = ppToeSegmentLength;
    #local ppTempDisplacement = vrotate(z*ppToeSegmentLength,ppBodyPartListOrientation[ppRightBigToeTipRef]);
    #local ppToeCentreLines[2][0] = ppToeCentreLines[1][0]+ppTempDisplacement; 
    #local ppTempDisplacement = vrotate(z*ppToeSegmentLength,ppBodyPartListOrientation[ppRightFirstToeTipRef]);
    #local ppToeCentreLines[2][1] = ppToeCentreLines[1][1]+ppTempDisplacement; 
    #local ppTempDisplacement = vrotate(z*ppToeSegmentLength,ppBodyPartListOrientation[ppRightMiddleToeTipRef]);
    #local ppToeCentreLines[2][2] = ppToeCentreLines[1][2]+ppTempDisplacement; 
    #local ppTempDisplacement = vrotate(z*ppToeSegmentLength,ppBodyPartListOrientation[ppRightThirdToeTipRef]);
    #local ppToeCentreLines[2][3] = ppToeCentreLines[1][3]+ppTempDisplacement; 
    #local ppTempDisplacement = vrotate(z*ppToeSegmentLength,ppBodyPartListOrientation[ppRightLittleToeTipRef]);
    #local ppToeCentreLines[2][4] = ppToeCentreLines[1][4]+ppTempDisplacement; 
    
    #local ppFootStartPos         = ppBodyPartListPosition[ppRightMiddleToeBaseRef];
    #local ppMiddleToeOrientation = ppBodyPartListOrientation[ppRightMiddleToeBaseRef];
    #local ppCalfStartPos         = ppBodyPartListPosition[ppRightCalfRef];
    #local ppCalfEndPos           = ppBodyPartListPosition[ppRightThighRef];
    #local ppFootOrientation      = ppBodyPartListOrientation[ppRightFootRef];
    #local ppHandedness = "Right";
    
//    #include ppIncludeFile
    ppBootGenerator();
    #declare ppRightBoot = object {ppBoot1}
    #declare ppRightBootRef = ppAddBodyPart("ppRightBootRef"object{ppRightBoot});  
  #end
#end  



// The ppLegwear macro for pphuman001accessories takes a series of body parts that have previously been added to the POV-Person 
// figure definition and assigns copies of them to a set of declared variables. It also assigns default values to a series of 
// control variables and invokes a routine to draw the style of legware specified in the first parameter.   
// 
// It is not anticipated that the general user will need to modify this macro. 
// 
// Note. The line used to scan the body parts will pass up the left leg, along to the right hip and down the right leg. Therefore
// the vector at the floppy end of the left leg will point towards the hips and the vector at the end of the right leg will point 
// away from the hips.  
//
// Parameters:
// -----------
//               - No parameters are passed to this macro. 
//
#macro ppLegwear()

  // Look up a bunch of attributes that are specific to the human001 model and use them to set a series of more generic 
  // control variables that can subsequently be used to define a variety of different forms of legwear.
  #declare ppLeftHipPos    = ppJointLocation(ppLeftHipJointRef);
  #declare ppRightHipPos   = ppJointLocation(ppRightHipJointRef);
  #declare ppLeftKneePos   = ppJointLocation(ppLeftKneeJointRef);
  #declare ppRightKneePos  = ppJointLocation(ppRightKneeJointRef);
  #declare ppLeftAnklePos  = ppJointLocation(ppLeftAnkleJointRef);
  #declare ppRightAnklePos = ppJointLocation(ppRightAnkleJointRef);
  #declare ppBodyCentre    = ppJointLocation(ppChestAbdomenJointRef);
    
  #declare ppLeftThighObject  = ppGetBodyPart(ppLeftThighRef)
  #declare ppRightThighObject = ppGetBodyPart(ppRightThighRef)
  #declare ppLeftCalfObject   = ppGetBodyPart(ppLeftCalfRef)
  #declare ppRightCalfObject  = ppGetBodyPart(ppRightCalfRef)
  #declare ppHipObject        = merge {
    ppGetBodyPart(ppHipRef)
    ppGetBodyPart(ppAbdomenRef)
  }
  
//  #include ppIncludeFile 
  ppShortsGenerator()
#end


// This macro provides an anatomy specific layer that then includes a generic POV-Person clothing file to generate tops 
// (shirts, jumpers etc).
// A version of this file is included with pphuman001accessories to take the anatomical parts defined as part of that model 
// and assign them to a set of object variables with names that are subsequently used by the generic clothes generation macros.
// It also assigns default values to a series of control variables before invoking a routine to draw the style of top 
// specified in the first parameter.   
// 
// It is not anticipated that the general user will need to modify this macro. 
// 
// Note. The line used to scan the body parts will pass up from the abdomen and into the neck. The vectors will point upwards 
// following the lines of the various body parts.  
//
// Parameters:
// -----------
//               - No parameters are passed to this macro. 
//
#macro ppTop()
  // Look up a bunch of attributes that are specific to the human001 model and use them to set a series of more generic 
  // control variables that can subsequently be used to define a variety of different forms of top.
  #declare ppLeftHipPos       = ppJointLocation(ppLeftHipJointRef);
  #declare ppRightHipPos      = ppJointLocation(ppRightHipJointRef);
  #declare ppAbdomenJointPos  = ppJointLocation(ppAbdomenHipJointRef);
  #declare ppChestJointPos    = ppJointLocation(ppChestAbdomenJointRef);
  #declare ppNeckJointPos     = ppJointLocation(ppLowerNeckJointRef);
  #declare ppHeadJointPos     = ppJointLocation(ppUpperNeckJointRef);
  #declare ppLeftShoulderPos  = ppJointLocation(ppLeftShoulderJointRef);
  #declare ppRightShoulderPos = ppJointLocation(ppRightShoulderJointRef);
    
  #declare ppTorsoObject        = merge {
    ppGetBodyPart(ppHipRef)
    ppGetBodyPart(ppAbdomenRef)
    ppGetBodyPart(ppChestRef)
    ppGetBodyPart(ppNeckRef) 
    ppGetBodyPart(ppLeftShoulderRef)
    ppGetBodyPart(ppRightShoulderRef)
  }
  #ifndef (ppFabricOffSet) #declare ppFabricOffSet = 0.015; #end
  ppShirtGenerator()
#end

/***************************************************************************************************/
/* The following alternative camera arrangements are used during the development of accessories.   */
/***************************************************************************************************/

#if (strcmp(ppCamera,"Boots")=0) 
  ppFootwear("ppboot1.inc","Both")
  object {ppLeftBoot}
  object {ppRightBoot}
  object {Ann}

  light_source { <2, 60,-10> color rgb<1, 1, 1>*1.6 }   
  light_source { <100, 14,100> color rgb<1, 1, 1>*2.2 }   
  light_source { <10, 50,1> color rgb<1, 0.5, 0.5>}   
//  camera {location <3, 1, 5> look_at <0, 0.8, 0>}
  camera {location <1.5,1,0.5> look_at <-0.01,0.5,0.2>}
#end   


#if (strcmp(ppCamera,"Shorts")=0)
  #declare ppTrouserLegTexture = texture {
    pigment {color rgbt <0.4,0.6,1,0>}  
    normal {bumps 0.8 scale <0.1,0.07,0.4>} 
    scale 0.5
  }
  ppLegwear("ppshorts1.inc")

  object {ppLegwear1}
//  object {Ann}

  light_source { <2, 60,-10> color rgb<1, 1, 1>*1.6 }   
  light_source { < 100, 14,100> color rgb<1, 1, 1>*2.2 }   
  light_source { <-100, 14,10> color rgb<1, 1, 1>*2.2 }   
  light_source { <-10, 1,-1> color rgb<1, 0.5, 0.5>}   
  light_source { <-0.7,0.7,0.2> color rgb<1, 1, 1>*1 }   
  camera {location <-0.1,1.1,1> look_at <0.1,0.8,0>}
#end   


#if (strcmp(ppCamera,"Trousers")=0)
  #declare ppTrouserLegTexture = texture {
    pigment {color rgbt <0.4,0.6,1,0>}  
    normal {bumps 0.8 scale <0.1,0.07,0.4>} 
    scale 0.5
  }
  ppLegwear("ppshorts1.inc")
  
  object {ppLegwear1}
//  object {Ann}

  light_source { <2, 60,-10> color rgb<1, 1, 1>*1.6 }   
  light_source { < 100, 14,100> color rgb<1, 1, 1>*2.2 }   
  light_source { <-100, 14,10> color rgb<1, 1, 1>*2.2 }   
  light_source { <-10, 1,-1> color rgb<1, 0.5, 0.5>}   
  light_source { <-0.7,0.7,0.2> color rgb<1, 1, 1>*1 }   
  camera {location <0.1,0.5,1.5> look_at <0.1,0.3,0>}
#end   

#if (strcmp(ppCamera,"Shirt")=0)  
//  #declare ppShowPoints = 1;
  ppTop("ppshirts1.inc")
  
  object {ppShirt1}
  object {Ann}

  light_source { <2, 60,-10> color rgb<1, 1, 1>*1.4 }   
  light_source { < 100, 14,100> color rgb<1, 1, 1>*1.2 }   
  light_source { <-100, 14,10> color rgb<1, 1, 1>*1.2 }   
//  light_source { <-10, 1,-1> color rgb<1, 0.5, 0.5>}   
//  light_source { <-0.7,0.7,0.2> color rgb<1, 1, 1>*1 }   
  camera {location <0.6,1.6,-0.8> look_at <0.1,1.5,0>}
#end   
                                                                          