/***************************************************************************************************/
/* pphuman001textures.inc  - Copyright Chris Bartlett 7 May 2004                                   */
/* This work is licensed for royalty free re-use under the terms of the POV-Person License.        */
/* To view a copy of this license, visit http://www.telinco.co.uk/c_bartlett/license/license.htm   */
/***************************************************************************************************/
 
#ifndef(ppSkinRedness)        #declare ppSkinRedness=1;        #end
#ifndef(ppSkinDarkness)       #declare ppSkinDarkness=1;       #end
#ifndef(ppSkinNoiseGenerator) #declare ppSkinNoiseGenerator=3; #end
#ifndef(ppSkinRandomiser)     #declare ppSkinRandomiser=100;   #else 
  #declare ppSkinRandomiser=ppSkinRandomiser+100; 
#end


#ifdef (ppSkinTexture) 
  #declare ppSkinTextureBase = texture {ppSkinTexture} 
#else 
  #declare ppSkinTextureBase = texture {
    pigment {  
      spotted
      color_map {
        [0   rgb <ppSkinRedness*22.8/255,(0.8+0.2*ppSkinRedness)*18.3/255,15.2/255>/ppSkinDarkness]
        [0.1 rgb <ppSkinRedness*228/255 ,(0.8+0.2*ppSkinRedness)*183/255 ,152/255 >/ppSkinDarkness]
        [0.3 rgb <ppSkinRedness*221/255 ,(0.8+0.2*ppSkinRedness)*177/255 ,142/255 >/ppSkinDarkness]
        [0.5 rgb <ppSkinRedness*228/255 ,(0.8+0.2*ppSkinRedness)*183/255 ,152/255 >/ppSkinDarkness]
        [0.7 rgb <ppSkinRedness*221/255 ,(0.8+0.2*ppSkinRedness)*183/255 ,152/255 >/ppSkinDarkness]
        [0.9 rgb <ppSkinRedness*228/255 ,(0.8+0.2*ppSkinRedness)*177/255 ,142/255 >/ppSkinDarkness]
        [1   rgb <ppSkinRedness*221/255 ,(0.8+0.2*ppSkinRedness)*177/255 ,142/255 >/ppSkinDarkness]
      }
      noise_generator ppSkinNoiseGenerator
    }
    finish {phong 0.1} 
    normal {agate 0.05 scale 0.2}
    scale 2 
    translate ppSkinRandomiser
  } 
#end
  
#declare ppAltSkinTexture_1 = texture {
  pigment {  
    spotted
    color_map {
      [0    rgbt <0,1,0,0>]
      [0.75 rgbt <0,1,0,1>]
      [1    rgbt <1,1,1,1> ]
    } 
  }
  finish {phong 0.3}
  scale 10 
}
   
#declare ppAltSkinTexture_2 = texture {
  pigment {  
    spiral1 1
    color_map {
      [0    rgbt <1,1,0,0>]
      [0.65 rgbt <1,1,0,0>]
      [0.65 rgbt <1,1,1,1>]
      [1    rgbt <1,1,1,1> ]
    } 
  }
  rotate x*90  scale <100000,20,100000> translate z*20 
}   

#declare ppAltSkinTexture_3 = texture {
  spiral1 1
  texture_map {
    [0    ppSkinTextureBase scale <0.00001,0.00001,0.05>]
    [0.65 ppSkinTextureBase scale <0.00001,0.00001,0.05>]
    [0.65 pigment {color rgbt <1,1,1,1>}]
    [1    pigment {color rgbt <1,1,1,1>}]
  }
  scale <100000,100000,20> rotate x*90 translate z*20 
}  

#ifndef (ppEyeshadowColour)  #declare ppEyeshadowColour  = <0,0.3,0.3,0.5>; #end
#ifndef (ppEyeshadowExtent) #declare ppEyeshadowExtent = 1; #end
#declare ppEyeshadowTexture = texture {
  pigment {  
    spherical
    color_map {
      [0   rgbt <1,1,1,1> ] 
      [0.85-0.15/ppEyeshadowExtent   rgbt ppEyeshadowColour ]
      [1   rgbt ppEyeshadowColour]
    } 
  }
  scale <28*ppEyeshadowExtent,15*ppEyeshadowExtent,22*ppEyeshadowExtent>
}   

#ifndef (ppBlusherColour)  #declare ppBlusherColour  = <1,0,0,0.5>; #end
#ifndef (ppBlusherExtent) #declare ppBlusherExtent = 0.4; #end
#declare ppBlusherTexture = texture {
  pigment {  
    spherical
    color_map {
      [0   rgbt <1,1,1,1> ] 
      [1   rgbt ppBlusherColour]
    } 
  }
  scale 30*ppBlusherExtent
}

#declare ppSkinTexture1 = texture {ppSkinTextureBase}

#declare ppFaceTexture1 =
  texture {ppSkinTextureBase} 
  texture {ppEyeshadowTexture translate ppEyePosition + <3*ppEyeshadowExtent,1,-2/ppEyeshadowExtent>}
  texture {ppEyeshadowTexture translate ppEyePosition + <3*ppEyeshadowExtent,1,-2/ppEyeshadowExtent> scale <-1,1,1>}
  texture {ppBlusherTexture   translate ppEyePosition + <3,-10,-7>}
  texture {ppBlusherTexture   translate ppEyePosition + <3,-10,-7> scale <-1,1,1>} 
   

#ifndef (ppLipColour) #declare ppLipColour = <1,0,0,0.4>; #end
#declare ppLipTexture =   
  texture {ppSkinTextureBase}
  texture {
    pigment { color rgbt ppLipColour}
    normal {radial frequency 80 turbulence 0.2
      slope_map {     
        [0   ,0]
        [0.48,0.3]
        [0.5 ,0.5] 
        [0.52,0.3]
        [1   ,0]
      }          
      rotate x*5
      translate <0,55,-12>    
    } 
    finish {phong 1}    
  }


#ifndef (ppLashLength)    #declare ppLashLength    = 20;      #end
#ifndef (ppLashDensity)   #declare ppLashDensity   = 0.6;     #end
#ifndef (ppLashThickness) #declare ppLashThickness = 0.026;   #end
#ifndef (ppLashColour)    #declare ppLashColour    = <0,0,0>; #end
  
#declare ppEyelashDisplacement = 6.2+1+ppLashLength/10;
#declare ppEyelashTextureBase = texture {   
  pigment { checker    
    pigment {color rgbt 1}
    pigment {  
      radial frequency 1
      turbulence 0
      color_map {
        [0                   rgbt ppLashColour]
        [ppLashThickness/2   rgbt ppLashColour]
        [ppLashThickness     rgbt <1,1,1,1>]
        [1-ppLashThickness   rgbt <1,1,1,1>]
        [1-ppLashThickness/2 rgbt ppLashColour]
        [1                   rgbt ppLashColour]
      }
    translate -x*ppEyelashDisplacement scale 1/1000 translate -<-1,0,0.5>
    }
  translate <-1,0,0.5> scale 1000 translate <ppEyelashDisplacement,-500,0>
  }
} 

// For the f1, m1 and m2 models, the following eye lash texture is used (lowercase).
#declare ppR1 = seed(0);
#declare ppEyelashtexture = texture {ppEyelashTextureBase translate -x*ppEyelashDisplacement}
#local   ppLashPosition = 0;

// For the f2 model, the following eye lash texture supercedes hte earlier one
#ifndef (ppEyeLashTexture) #declare ppEyeLashTexture = texture {pigment {color <0,0,0>}};  #end

#while (ppLashPosition < 180)
  #declare ppEyelashtexture = 
    texture {ppEyelashtexture}
    texture {ppEyelashTextureBase translate -x*(6.2+0.5+rand(ppR1)/2+ppLashLength/10) rotate -y*ppLashPosition translate x*0.5}
  #declare ppLashPosition = ppLashPosition+(1+3*rand(ppR1))/ppLashDensity;   // increment our counter
#end
   
#ifndef (ppEyebrowHairThickness) #declare ppEyebrowHairThickness = 0.030;             #end 
#ifndef (ppEyebrowHairColour)    #declare ppEyebrowHairColour    = <0.2,0.2,0.1,0.6>; #end 

#declare ppEyebrowTexture = texture {
  pigment {  
    radial frequency 500 turbulence 0.1
    color_map {
      [0.2  rgbt ppEyebrowHairColour]
      [0.2+ppEyebrowHairThickness rgbt ppEyebrowHairColour]
      [0.52 rgbt <1,1,1,1>]
      [0.5  rgbt ppEyebrowHairColour]
      [0.5+ppEyebrowHairThickness  rgbt ppEyebrowHairColour]
      [0.98 rgbt <1,1,1,1>]
    }      
  } 
  finish {phong 0.2}
  normal {  
    radial frequency 500 turbulence 0.1   
  }
}   
          
#ifndef (ppCamera) 
  camera {
    location <0, 30, -120>
    look_at <0, 00, 0>
    angle 34.3775
  }
  
  light_source { <250, 60,-8900> color rgb<1, 1, 1>*0.6 }   
  light_source { <0, 1400,-1600> color rgb<1, 1, 1>*1.2 }   
  light_source { <0, 60,0> color rgb<1, 0.5, 0.5>}  
  cylinder {<-60, 0,0><60, 0,0>,2 texture {ppEyeshadowTexture}} 
  sphere {<0,0,0>,25 texture {ppAltSkinTexture_3}} 
//  sphere {<-20, 20,0>,10 texture {SkinTexture}} 
//  sphere {< 20, 20,0>,10 texture {liptexture}} 
  sphere {<0,0,0>,20 texture {ppEyelashTextureBase} translate <-20,-20,0> rotate -x*45} 
//  sphere {<-20,-20,0>,10 texture {eyelashTextureBase}} 
//  sphere {< 20,40,0>,10 texture {eyebrowtexture}} 
  plane {y,-40 pigment {rgb <1,1,1>}}
#end                                                    

            
