/***************************************************************************************************/
/* pps2beardline.inc  - Copyright Chris Bartlett 2005                                              */
/* This work is licensed for royalty free re-use under the terms of the POV-Person License.        */
/* To view a copy of this license, visit http://www.telinco.co.uk/c_bartlett/license/license.htm   */
/***************************************************************************************************/

#ifndef(ppCamera)  #declare ppCamera="BeardLineFront";  #end      // Required to prevent camera definitions in the include files being used.

#declare ppBeardLine = difference {
  object {ppHeadShell}
  sphere {0,0.4
    scale <2.7,2.2,1.2>
    rotate x*25
    translate < 0,0,-0.4> 
  }
  sphere {0,0.41
    scale <2.7,2.5,1.7>
    rotate x*25
    translate < 0,-0.25,0.2> 
  }
  translate y
  scale 100  
  translate z*40
}

//#local ppBeardLineShape = merge {
//  // Mouth
//  sphere {0,0.4
//    scale <1.4,1.2,1> 
//    translate <0,-0.68,-0.715>
//  } 
//  
//  // Lower Beard
//  sphere {0,0.39
//    scale <2.4,3.3,1.4>
//    rotate x*37
//    translate < 0,-0.7,-0.4> 
//  }
//   
//  // Jaw Line
//  sphere {0,0.4
//    scale <2.7,2.9,2>
//    rotate x*30
//    translate < 0,-0.36,0> 
//  }
//}
//
//#ifndef (ppMouthLine)
//  #declare ppMouthLine = prism {
//    linear_spline
//    0, 1, 14,
//    <-0.42,0.1>, <-0.3,0.09>, <-0.09,0.1>, <0,0.05>,<0.09,0.1>, <0.3,0.09>, <0.42,0.1> // Upper Lip
//    <0.25,-0.025>,<0.17,-0.06>,<0.07,-0.08>, <0,-0.078>, <-0.07,-0.08>,<-0.17,-0.06>,<-0.25,-0.025>  // Lower Lip
//     
//    rotate -x*90
//    translate <0,-0.68,-0.8>
//  }
//#end 
//
////object {ppMouthLine pigment {color rgb <1,1,0>}
////  translate <0,1.5,0>
////}
//
//#declare ppBeardLine = difference {
//  object {ppBeardLineShape}
//  object {ppBeardLineShape scale 0.9999999}
//  sphere {0,0.4
//    scale <2.7,2.2,1.2>
//    rotate x*25
//    translate < 0,0,-0.4> 
//  }
//  sphere {0,0.41
//    scale <2.7,2.5,1.7>
//    rotate x*25
//    translate < 0,-0.25,0.2> 
//  }
//  object {ppMouthLine}
//  translate y
//  scale 100  
//  translate z*40
//} 

#if (strcmp(ppCamera,"BeardLine")=0)  
  object {ppBeardLine pigment {color rgb <1,1,1>} scale 0.01}
  light_source { < 2, 60  ,-30> color rgb<1, 1  , 1  >*0.6 }   
  light_source { < 0, 24  ,-26> color rgb<1, 1  , 1  >*1.2 }   
  light_source { <5,  6.5,-10> color rgb<1, 0.5, 0.5>}   
  camera {  
    location <-4, 1,-2>
    look_at  <0, 0.5, 0>
    right x*0.8
    up y*0.8*3/4
  }
#end 
 
#if (strcmp(ppCamera,"BeardLineFront")=0)  
  object {ppBeardLine pigment {color rgb <1,1,1>} scale 0.01}
  light_source { < 2, 60  ,-30> color rgb<1, 1  , 1  >*0.6 }   
  light_source { < 0, 24  ,-26> color rgb<1, 1  , 1  >*1.2 }   
  light_source { <5,  6.5,-10> color rgb<1, 0.5, 0.5>}   
  camera {  
    location <0, 0.5,-5>
    look_at  <0, 0.5, 0>
    right x*0.8
    up y*0.8*3/4
  }
#end 
